#ifndef __COMMON_H__
#define __COMMON_H__

#ifndef FALSE
#define FALSE (0)
#define TRUE  (!FALSE)
#endif

/**
 * Type of functions used to visit elements of a collection.
 */
typedef void (*VisitorFunc)     (void *data, void *extra_data);

/**
 * Type of functions used to visit elements of a collection until the visitor
 * returns FALSE.
 */
typedef int  (*CancellableVisitor) (void *data, void *extra_data);

/**
 * Type of the functions used to visit a pair (a,b) of values.
 */
typedef void (*PairVisitor)   (void *a, void *b, void *extra_data);

/**
 * Type of the functions used to visit a triplet (a,b,c) of values.
 */
typedef void (*TripletVisitor)   (void *a, void *b, void *c, void *extra_data);

/**
 * Functions of this type should return 0 if the objects pointed to by 'a' and
 * 'b' are different, or a value different from 0 if the objects are equal.
 */
typedef int (*EqualsFunc) (void *a, void *b);

#endif /* __COMMON_H__ */
