#ifndef __GRAPH_FUNCTIONS_H__
#define __GRAPH_FUNCTIONS_H__

typedef struct {
        /*
         * Public functions
         */
        int    (*add_edge)            (void *_graph, vertex from_a, vertex to_b, weight weight);
        int    (*exists_edge)         (void *_graph, vertex a, vertex b);
        size_t (*number_of_vertices)  (void *_graph);
        size_t (*number_of_edges)     (void *_graph);
        int    (*is_connected)        (void *_graph);
        int    (*vertex_is_on_path)   (void *_graph, vertex v, vertex from, vertex to);
        void   (*destroy)             (void *_graph);

        /* Private field */
        void   *private_data;  /* implementors can store a reference to its 
                                  internal representation here */
} GraphImpl;

#endif /* __GRAPH_FUNCTIONS_H__ */
